Subject: Re: Link bouncing with multiple drivers.

From: Ben Greear <[email-masked]>
Date: Mon, 12 Oct 2009 14:08:56 -0700

On 10/12/2009 10:55 AM, Ben Greear wrote:
> I have a strange issue:
>
> In several different scenarios, when we run pktgen at line speed
> on 1G through our proprietary bridge-ish module, we see link go
> up and down every minute or so. This happens with e1000, e1000e,
> and have also seen it on ixgbe (though not line speed here...but
> we were driving it as hard as the systems could handle).
>
> We cannot reproduce this when a normal bridge is substituted for
> our proprietary module, so it must either be a bug in our code somewhere,
> or something to do with the fact that our module causes more work to
> be done than a bridge (backed up driver queues on rx/tx, time-stamps, etc).
>
> Since it happens across multiple drivers and hardware (and operating
> systems: F5, F8, F11,
> but all with kernels based on 2.6.31), it must be some general issue.
>
> If anyone has any ideas where I should start poking, I would
> be grateful. For now, I'm off to dig in the e1000e code...

Ahh, it was indeed my bug.  I forgot to update the txqueue trans_start and that
caused the watchdog to fire way too often.

Thanks,
Ben

-- 
Ben Greear <[email-masked]>
Candela Technologies Inc  http://www.candelatech.com